{Soubor PENTAGO2.PAS}
{druha verze programu PENTAGON, tentikrat s prilinkovanym ovladacem grafiky}
{ ukazuje pouziti funkce REGISTERBGIDRIVER }
{zde komwentujeme pouze veci odlisne od predchozi verze,}
{komentare k vlastnimu programu najdete v souboru PENTAGO1.PAS}

program pentagon;

uses  graph, crt;

{cesta k ovladaci graficke karty}
{protoze se ovladac prilinkuje, je cesta prazdna }
const cesta = '';

{deklarace externi procedury VGA, ktera vznikne konverzi ovladace
 EGAVGA.BGI; postup konverze viz komentar na konci souboru}

procedure vga; external; {nasledujici direktiva v komentari najde }
                         {proceduru vga  v souboru EBAVGA.OBJ }
                         {a pripoji ji k nasemu programu}
{$L egavga.obj }

type bod = record
   x, y: integer;
   end;

   vrcholy = array[1..5] of bod;

procedure VytvorPetiuhelnik(s: bod; r: integer; var p: vrcholy);
var
   b, b1: bod;
   sf, cf: real;
   i, xx, yy: integer;
begin
   b.x := r;
   b.y := 0;
   p[1].x := b.x + s.x;
   p[1].y := b.y + s.y;
   sf := sin(72*pi/180); cf := cos(72*pi/180);
   for i:= 2 to 5 do
   begin
     b1.x := round(b.x*cf - b.y*sf);
     b1.y := round(b.x*sf + b.y*cf);
     b := b1;
     p[i].x := b1.x + s.x;
     p[i].y := b1.y + s.y;
   end;
end;

procedure NakresliPetiuhelnik(var p: vrcholy);
var
  i: integer;
begin
    moveto(p[5].x, p[5].y);
    for i := 1 to 5 do lineto(p[i].x, p[i].y);
end;

var
   driver, mode: integer;
   v: vrcholy;
   s: bod;
   r: integer;
   c: char;

begin
  clrscr;
  write('zadej stred petiuhelnika v obrazovkovych souradnicich: ');
  read(s.x, s.y);
  write('zadej polomer kruznice opsane: ');
  read(r);
  {nez spustime grafiku, musime zaregistrovat ovladac}
  registerbgidriver(@vga);
  driver := detect;
  initgraph(driver, mode, cesta);
  if(driver < 0) then
  begin
     writeln('nepodaril se start grafiky');
     halt
  end;
  VytvorPetiuhelnik(s, r, v);
  NakresliPetiuhelnik(v);
  OutTextXY(10, getmaxy-10, 'stiskni klavesu...');
  c := readkey;
  closegraph;
end.

{Konverze grafickeho ovladace do formatu OBJ:
1. Do pracovniho adresare okopirujeme soubor EGAVGA.BGI (pripadne jiny
   ovladac, ktery chceme pouzit). Najdeme jej v instalaci Pascalu v
   adresari BGI. Dale si do pracovniho adresare okopirujeme soubor BINOBJ.EXE
   z adresare BIN z instalace Pascalu.

2. Z prikazove radky DOSu zadame prikaz
   BINOBJ EGAVGA.BGI EGAVGA.OBJ VGA
   Za jmenem programu nasleduji parametry: jmeno konvertovaneho souboru,
   jmeno vysledneho souboru (zde egavga.obj), jmeno, ktere chceme
   dat vytvoreme procedure (zde VGA).
   Tim vytvorime v pracovnim adresari soubor egavga.obj, ktery obsahuje
   proceduru vga.

3. V programu deklarujeme proceduru VGA jako externi a direktivou
   v komentari}
   {$L egavga.obj}
   {rekneme prekladaci, ze ma tento soubor priopojit v programu.

4. Volanim procedury REGISTERBGIDRIVER "zaregistrujeme" ovladac, tj.
   sdelime programu, ze jako ovladac graf. systemu ma pouzit proceduru VGA.
   Pri violani teto procedury je treba dat pred identifikator VGA
   operator "@".

5. Pri volani INITGRAPH uvedeme jako cestu prazdny retezec.
}


