(***********************************************************************
	PROGRAM.PAS
  druh verze, prvn pokus o pozdn vazbu
  Pouit pozdn vazby, i by implementovan "na kolen", umon
  napsat program podstatn elegantnji: odpadne nutnost poznamenvat
  si u ukazatele skuten typ instance a podle nj rozliovat metodu,
  kterou volme.
  Ovldn programu je stejn jako v minul verzi.
***********************************************************************)

uses Pomoc, Graf1, Graph, Crt;

type pBod = ^Bod;
     pKruh = ^Kruh;
     pUsecka = ^Usecka;

var c     : Pohyb;
    cc    : char;
    Objekty: array [1..100] of pBod; { pole objekt }
    index : 1..100;     { poadov slo objektu v poli }
    i     : integer;

const oCo = 10;   { velikost posunu objektu }
      rr = 2;     { vzdlenost ar v rmeku }

const I1 = 'B: bod    K: kruznice   U: usecka   Q: konec';
      I2 = #24#25#26#27' posun   PgUp/PdDn zmena velikosti   O otoceni   Esc umisten';
      { text npovdy }

procedure Ramecek;     { rmeek grafick obrazovky }
 begin
  moveto(0,0);
  lineto(xx,0);
  lineto(xx,yy);
  lineto(0,yy);
  lineto(0,0);
  moveto (rr,rr);
  lineto(xx-rr,rr);
  lineto(xx-rr,yy-rr);
  lineto(rr,yy-rr);
  lineto(rr,rr);
 end;

procedure Obnova; { obnova rmeku a grafickch objekt }
begin             { pokozench pechodem jinho objektu }
 Ramecek;
  for i := 1 to index-1 do Objekty[i]^.Obnov;
  Instrukce(I1);  { zobrazen npovdy }
end;

begin
 SpustGrafiku(cesta);
 Ramecek;
 Instrukce(I1);
 c := Vlevo;
 index := 1;
 repeat    { interpretan cyklus pro vytven objekt }
  cc := readkey;
  if cc in ['b', 'B', 'u', 'U', 'k', 'K', 'Q', 'q'] then begin
    Instrukce(I2);
    case cc of
     'b', 'B':  { Bod }
        Objekty[index] := new(pBod, Udelej(xx div 2, yy div 2));
     'k','K':    { Krunice }
        Objekty[index] := new(pKruh, Udelej(xx div 2, yy div 2, 50));
     'u','U':    { seka }
        Objekty[index] := new(pUsecka, Udelej(xx div 2, yy div 2));
      'q','Q':  c := Konec;  { Konec programu }
    end;
    if (c <> Konec) then begin
        Objekty[index]^.Nakresli;
        Objekty[index]^.UsadSe(oCo);
        inc(index);
        Obnova;
    end;
  end;
 until c = Konec;
 for i := 1 to index-1 do
    Dispose (Objekty[i] , Zrus);
 UkonciGrafiku;
end.