{
 UKAZKA aktualizace binarniho souboru a formatovani textoveho vystupu

 Tento program precte z textoveho souboru data.dta jmena, prijmeni
 a platy zamestnancu a ulozi je do binarniho souboru banda.dta.
 Pak vypise tabulku zamestnancu.
 Dale zvysi jednomu ze zamestnancu plat a opet vypise prehled.
}

uses crt;
const                             {jmena souboru}
     vstup = 'data.dta';          {textovy soubor se jmeny}
     hlavni = 'banda.dta';        {binarni, pracovni soubor}

type zamestnanec = record         {data o zamestnanci}
         jmeno: string [20];
         prijmeni: string[20];
         plat: word;
     end;

var x: zamestnanec;
    f: file of zamestnanec;
    g: text;
    pozice: longint;

procedure priprava;                   { Tato procedura precte z textoveho}
begin                                 { souboru jmena, prijmeni a platy }
    rewrite(f);                       { POZOR: pri cteni typu string se cte}
    reset(g);                         { vzdy az do konce radku !! Proto jsou}
    while not seekeof(g) do           { v soub. DATA.DTA jmeno, prijmeni }
    begin                             { a plat na zvlastnich radcich ! }
        readln(g, x.jmeno);           { MUSIME POUZIT READLN, nebot read  }
        readln(g, x.prijmeni);        { pri cteni retezce neumi prejit na }
        readln(g, x.plat);            { novy radek!}
        write(f, x);
    end;
    close(f);
    close(g);
end;

procedure ZvysPlat(Komu: string; okolik: word);
begin
    reset(f);
    while not eof(f) do                 {Aktualizacni procedura }
    begin                               {cte zaznam po zaznamu}
     read(f, x);                        
      if x.prijmeni = komu then         {pokud najde retezec KOMU, }
      begin
        x.plat := x.plat + okolik;      {upravi plat o danou castku}
        if eof(f) then pozice := filesize(f)   {zjisti aktualni pozici v souboru}
        else pozice := FilePos(f);
        seek(f, pozice-1);              {vrati se o jeden zaznam zpet}
        write(f, x);                    {a prepise puvodni zaznam novou }
      end;                              {hodnotou}
    end;
end;

procedure Vypis;                  {Vypise prehled zamestnancu}
begin                             {Ukazuje formatovani vystupu}
    reset(f);
    writeln('Vypis zamestnancu: ');
    writeln('Jmeno' : 20, 'Prijmeni': 20,'          ', 'Plat':10);
    writeln('------------------------------------------------------------');

    while not eof(f) do
    begin
      read(f, x);
      writeln(x.jmeno:20, x.prijmeni:20, x.plat:20);
    end;
end;

begin
    clrscr;
    assign(g, vstup);
    assign(f, hlavni);
    priprava;
    Vypis;
    ZvysPlat('Ledvina', 1000);
    Vypis;
end.

{
 Poznamky:
   operace cteni nebo zapisu posune ukazovatko na aktualni pozici
   o jeden zaznam dopredu. Pri aktualizace se proto musime o jeden
   zaznam vratit, abychom prepsali prave precteny zaznam.

   Ke zjisteni aktualni pozice v souboru slouzi funkce filepos,
   celkovy pocet zaznamu v souboru vrati funkce filesize (tu pouzijeme,
   jsme-li na konci souboru).
   K nastaveni pozice slouzi funkce seek.

   Pozor pri formatovani: cisla se zarovnavali doprava, stringy doleva.

   Cteni z textoveho souboru
     polozku se oddweluji mezerami, ale pozor!!
     u typu string se cte vzdy do konce radku!!
     na novy radek nutno prejit pomoci READLN.

}