uses seznam, crt;

type Tcislo = object(Tseznam)
   znamenko: integer;
   constructor Cti;
   destructor done;
   procedure vypis;
   constructor Soucet(var a, b: TCislo);
end;

constructor TCislo.Cti;
var
  c: char;
  JeZnamenko: Boolean;
const
  ENTER = #13;
begin
  Tseznam.Init;
  JeZnamenko := false;
  writeln;
  c := readkey;
  while c <> ENTER do begin
   case c of
    '0' .. '9':
      begin
          if not JeZnamenko then begin
              znamenko := 1;
              JeZnamenko := true;
          end;
          VlozNaKonec(ord(c)-ord('0'));
          write(c);
      end;
    '+','-':
      if not JeZnamenko then begin
         write(c);
         JeZnamenko := true;
         if c = '-' then znamenko := -1 else znamenko := 1;
      end;
   end;
   c := readkey;
  end;
end;

destructor TCislo.done;
begin
    inherited done;
end;

procedure TCislo.vypis;
var p: PPrvek;
begin
   writeln;
   if znamenko < 1 then write('-') else write('+');
   p := phlava^.TenDalsi;
   while p <> pzarazka do begin
       write(p^.Hodnota);
       p := p^.TenDalsi;
   end;
end;

constructor TCislo.Soucet(var a, b: TCislo);
var
  pa, pb, ph: PPrvek;
  prenos, souc: integer;
begin
  TSeznam.INIT;
  pa := a.pzarazka^.TenPredch;
  pb := b.pzarazka^.TenPredch;
  znamenko := 1;
  prenos := 0;

  while (pa <> a.phlava) and (pb <> b.phlava) do begin
    souc := pa^.Hodnota + pb^.Hodnota + prenos;
    if souc > 9 then begin
        souc := souc mod 10;
        prenos := 1;
    end else
       prenos := 0;
    VlozNaZacatek(souc);
    pa := pa^.TenPredch;
    pb := pb^.TenPredch;
  end;
  if a.delka < b.delka then begin
    pa := pb;
    ph := b.phlava;
  end else
    ph := a.phlava;

  while pa <> ph do begin
     souc := prenos + pa^.Hodnota;
     if souc > 9 then begin
         souc := souc mod 10;
         prenos := 1;
     end else
        prenos := 0;
     VlozNaZacatek(souc);
     pa := pa^.TenPredch;
  end;
  if prenos > 0 then VlozNazacatek(prenos);
end;

var Cis1, Cis2, Cis3: TCislo;

begin
   Cis1.Cti;
   Cis2.Cti;
   Cis3.Soucet(Cis1, Cis2);
   Cis3.Vypis;
   Cis3.done;
   Cis2.done;
   Cis1.done;
end.